#include <ep93xx/ioregs.h>
#include <target/io.h>

#include "board.h"

#define BIT(no) (1<<no)

int get_board_id(void){
  static int flag = 0;
  static unsigned long id;

  if(flag == 0){
    unsigned long mask;

    IO_SYSSWLOCK = 0xaa;//Lcok Open
    IO_DEVICECFG |= 0x00000d00;

    mask = (BIT(2) | BIT(3) | BIT(4) | BIT(5));
    
    //PortH:Bit[2-5] => INPUT
    IO_GPIO_PHDDR &= ~mask;
    id = ((IO_GPIO_PHDR & mask) >> 2);

    flag = 1;
  }

  return (int)id;
}

char *get_board_name(int id){
  switch(id){
  case BOARD_ID_A210: return "Armadillo J210";
  default:            return "unknown";
  }
  return "";
}

int jumper_mode = 0;
int check_mode_jumper(void){
  if(IO_GPIO_PBDR & JP_MODE_BIT){
    //Linux-Boot Mode
    jumper_mode = 0;
    return 0;
  }else{
    //Hermit Mode
    jumper_mode = 1;
    return 1;
  }
}
